#include "DHT.h"
#include <ModbusRtu.h>
DHT _dht1(3, DHT11);

Modbus _modbusSlave(1, 0, 2);
uint16_t _ModbusReg[3];
int _gtv1;
int _gtv2;
unsigned long _dht1Tti = 0UL;
float _dht1t = 0.00;
float _dht1h = 0.00;
bool _gen1I = 0;
bool _gen1O = 0;
unsigned long _gen1P = 0UL;
void setup()
{
_modbusSlave.begin(9600);
pinMode(13, OUTPUT);

_dht1.begin();
}
void loop()
{_modbusSlave.poll(_ModbusReg, 3);
if(_isTimer(_dht1Tti, 3000)) {
_dht1Tti = millis(); 
float tempDht3;
 tempDht3 = _dht1.readTemperature();
if (!(isnan(tempDht3))){_dht1t=tempDht3; }
 tempDht3 = _dht1.readHumidity();
if (!(isnan(tempDht3))){_dht1h=tempDht3; }
}



if ((bitRead(((int(_ModbusReg[0]))), (0)))) { if (! _gen1I) { _gen1I = 1; _gen1O = 1; _gen1P = millis(); } } else { _gen1I = 0 ; _gen1O= 0;}
 if (_gen1I) {  if ( _isTimer ( _gen1P , 500 )) { _gen1P = millis(); _gen1O = ! _gen1O;}}
_gtv1 = _dht1t;
_gtv2 = _dht1h;
_ModbusReg[1] = _gtv1;
_ModbusReg[2] = _gtv2;
digitalWrite(13, _gen1O);




}
bool _isTimer(unsigned long startTime, unsigned long period )
  {
  unsigned long currentTime;
currentTime = millis();
if (currentTime>= startTime) {return (currentTime>=(startTime + period));} else {return (currentTime >=(4294967295-startTime+period));}
  }
